<template>
  <div class="wrap-search-btn">
    <v-autocomplete
      v-model="data"
      :hide-no-data="!search"
      :items="items"
      :search-input.sync="search"
      hide-selected
      deletable-chips
      dense
      flat
      height="33px"
      background-color="#FAFAFA"
      class="rounded-lg"
      return-object
      label="Escribe el título o # el tag que busques, p. ej."
      item-text="descripcion"
      item-value="idEtiqueta"
      placeholder="#Trabajo Equipo"
      @change="searchAction"
    >
      <template v-slot:append>
        <div class="pr-2">
          <v-icon>mdi-magnify</v-icon>
        </div>
      </template>
      <template v-slot:selection="{ attr, on, item, selected }">
        <v-chip
          small
          v-bind="attr"
          :input-value="selected"
          color="blue-grey"
          class="white--text"
          v-on="on"
        >
          <v-icon left>
            mdi-pound-box-outline
          </v-icon>
          <span v-text="item.descripcion"></span>
        </v-chip>
      </template>
    </v-autocomplete>
  </div>
</template>
<style>
.wrap-search-btn .v-input__append-outer {
  margin-left: 0px;
}
</style>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Etiquetas",
  props: {
    value: null,
    searchAction: null,
    disabled: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data: () => ({
    search: null,
    items: [],
  }),
  computed: {
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    getEtiquetas() {
      const self = this;
      axios("/modelo-negocio/catalogos/etiquetas/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.etiquetas.map((item) => {
              self.items.push(item);
            });
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    filter(item, queryText, itemText) {
      const hasValue = (val) => (val != null ? val : "");
      const descripcion = hasValue(itemText);
      const query = hasValue(queryText);
      return (
        descripcion
          .toString()
          .toLowerCase()
          .indexOf(query.toString().toLowerCase()) > -1
      );
    },
  },
  created() {
    this.getEtiquetas();
  },
};
</script>
